﻿using System;
using System.ComponentModel.DataAnnotations;
using EPiServer;
using EPiServer.Core;
using EPiServer.DataAbstraction;
using EPiServer.DataAnnotations;
using EPiServer.Web;

namespace EPiServer.Templates.Alloy.Models.Blocks
{
    [ContentType(GUID = "5FF99382-38DA-4356-98E7-F42A45F64F1D",
        DisplayName = "iFrame Block",
        Description = "Display content from another URL in an iFrame")]
    [SiteImageUrl]
    public class iFrameBlock : SiteBlockData
    {
        [Editable(true)]
        [Display(
            Name = "URL",
            Description = "Enter URL to display in an iFrame",
            GroupName = SystemTabNames.Content,
            Order = 1)]
        [Required]
        public virtual Url URL { get; set; }

        [Display(
            Name = "Heading",
            Description = "Heading",
            GroupName = SystemTabNames.Content,
            Order = 2)]
        public virtual String Heading { get; set; }

        [Display(
            Name = "Text",
            Description = "Descriptive text",
            GroupName = SystemTabNames.Content,
            Order = 3)]
        public virtual XhtmlString Text { get; set; }

        [Display(
            Name = "Width",
            Description = "Enter number of pixels (e.g. '600'), percent (e.g. '100%'), or leave empty. Note that usage of % is not supported by HTML5.",
            GroupName = SystemTabNames.Content,
            Order = 4)]
        public virtual String Width { get; set; }

        [Display(
            Name = "Height",
            Description = "Enter number of pixels (e.g. '600'), percent (e.g. '100%'), or leave empty. Note that usage of % is not supported by HTML5.",
            GroupName = SystemTabNames.Content,
            Order = 5)]
        public virtual String Height { get; set; }

        [Display(
            Name = "Scrollable",
            Description = "Select if you want the frame to be scrollable",
            GroupName = SystemTabNames.Content,
            Order = 6)]
        public virtual Boolean Scrollable { get; set; }

        //Sets the default property values
        public override void SetDefaultValues(ContentType contentType)
        {
            base.SetDefaultValues(contentType);

            Width = "100%"; // % not supported by HTML5
            Height = "100%"; // % not supported by HTML5
            Scrollable = true;
        }
    }
}